#include "GameObject.h"
#include "StateMod.h"
#include "Physics.h"

void GameObject::addStateMod(StateMod* const mod) {
	mod->apply(this);
	stateMods.push_back(mod);
}

aabb2 GameObject::getPhysicsBounds() const
{
	return toAabb2(m_body->GetFixtureList()->GetAABB(0));
}

vec2 GameObject::getRenderPosition() const
{
	return position * g_worldScale;
}
