#pragma once
#include <cJSON.h>

#if 0

template<> inline cJSON* jsonMarshall(const vec2& src) {
	return cJSON_CreateFloatArray(&src.x, 2);
}
template<> inline void jsonDemarshall(const cJSON* json, vec2* dst) {
	dst->x = (float)cJSON_GetArrayItem(const_cast<cJSON*>(json), 0)->valuedouble;
	dst->y = (float)cJSON_GetArrayItem(const_cast<cJSON*>(json), 1)->valuedouble;
}


template<> inline cJSON* jsonMarshall(const std::string& src) {
	return cJSON_CreateString(src.c_str());
}
template<> inline void jsonDemarshall(const cJSON* json, std::string* dst) {
	assert(json->type == cJSON_String);
	*dst = json->valuestring;
}


template<> inline cJSON* jsonMarshall(const int& src) {
	return cJSON_CreateNumber(src);
}
template<> inline void jsonDemarshall(const cJSON* json, int* dst) {
	assert(json->type == cJSON_Number);
	*dst = json->valueint;
}


template<> inline cJSON* jsonMarshall(const float& src) {
	return cJSON_CreateNumber(src);
}
template<> inline void jsonDemarshall(const cJSON* json, float* dst) {
	assert(json->type == cJSON_Number);
	*dst = json->valuedouble;
}


template<> inline cJSON* jsonMarshall(const u32& src) {
	return cJSON_CreateNumber(src);
}
template<> inline void jsonDemarshall(const cJSON* json, u32* dst) {
	assert(json->type == cJSON_Number);
	*dst = json->valueint;
}


template<> inline cJSON* jsonMarshall(const bool& src) {
	return cJSON_CreateBool(src);
}
template<> inline void jsonDemarshall(const cJSON* json, bool* dst) {
	assert(json->type == cJSON_True || json->type == cJSON_False);
	*dst = json->type == json->type;
}

#endif
