#pragma once
#include "Asset.h"
#include "Reflection.h"
#include <Framework/Graphics.h>
#include <Framework/Marshall.h>

#if 0

struct SpriteAsset {
	struct Render {
		TextureHandle texture;
		glm::ivec2 offset = glm::ivec2(0, 0);
		int w = 0;
		int h = 0;
	};

	struct Info {
		std::vector<ColorRGBA8> pixels;
		glm::ivec2 origSize = glm::ivec2(0, 0);
	};

	struct Url {
		std::string filename;
		u32 colorKey;
		bool clip;

		RTTI(Url,
			MEMBER(filename)
			MEMBER(colorKey)
			MEMBER(clip));
	};
};


struct SpritePool {
	SoaVector<SpriteAsset::Url, SpriteAsset::Render, SpriteAsset::Info> sprites;

	AssetHandle<SpriteAsset> load(const SpriteAsset::Url& uri);
	cJSON* marshall() const;
	void demarshall(cJSON*);
};

extern SpritePool g_spritePool;


template<> inline cJSON* jsonMarshall(const AssetHandle<SpriteAsset>& src) {
	return cJSON_CreateNumber(src.getId());
}
template<> inline void jsonDemarshall(const cJSON* json, AssetHandle<SpriteAsset>* dst) {
	assert(json->type == cJSON_Number);
	*dst = AssetHandle<SpriteAsset>::create(json->valueint);
}
#endif
