x = rand(1, 10000);
y = rand(1, 10000);

minAllowableDistance = 0.05;
numberOfPoints = 300;

keeperX = x(1);
keeperY = y(1);

counter = 2;
for k = 2 : numberOfPoints

    thisX = x(k);
    thisY = y(k);
    
    distances = sqrt((thisX-keeperX).^2 + (thisY - keeperY).^2);
    minDistance = min(distances);
    if minDistance >= minAllowableDistance
        keeperX(counter) = thisX;
        keeperY(counter) = thisY;
        counter = counter + 1;
    end
end
plot(keeperX, keeperY, 'b*');
grid on;