#pragma once

#include "Common.h"
#include "Raft.h"
#include <vector>

struct RaftPartBlueprint;
class RaftPartLibrary;
struct Raft;

/*struct RaftCraft : BoatyBase {
	struct CraftPart {
		//RaftPartBlueprint* part;
		//ivec2 offset;
		//std::vector<CraftPart> payload;

		int area() const;
	};

	std::vector<CraftPart> parts;
	Rafter rafter;

};*/

struct RaftGen {
	RaftGen(RaftPartLibrary* lib);

	Raft* generateRaft(vec2 position, int targetArea, bool isPlayer);
	Raft* makeTestRaft(vec2 position, bool isPlayer);

private:
	RaftPartLibrary& lib;
	std::vector<RaftPartBlueprint*> platforms;
	std::vector<RaftPartBlueprint*> attachments;
	std::vector<RaftPartBlueprint*> payloads;
};
