#pragma once

#include <vector>

#if 0
template <typename... Ts>
struct SoaVector {
	void push_back() {}
	void clear() {}
};

template <typename T, typename... Ts>
struct SoaVector<T, Ts...> : SoaVector<Ts...> {
	std::vector<T> items;

	void push_back(const T& t0, const Ts&... t1) {
		items.push_back(t0);
		SoaVector<Ts...>::push_back(t1...);
	}

	void clear() {
		items.clear();
		SoaVector<Ts...>::clear();
	}

	size_t size() const {
		return items.size();
	}

	template <typename X>
	X& get(size_t idx) {
		return SoaVector<Ts...>::get<X>(idx);
	}

	template <>
	T& get<T>(size_t idx) {
		return items[idx];
	}

	template <typename X>
	const X& get(size_t idx) const {
		return SoaVector<Ts...>::get<X>(idx);
	}

	template <>
	const T& get<T>(size_t idx) const {
		return items[idx];
	}
};

template <typename AssetType>
struct AssetHandle {
	u32 getId() const {
		return id;
	}

	static AssetHandle create(u32 id) {
		AssetHandle h;
		h.id = id;
		return h;
	}

	bool operator==(const AssetHandle& other) const {
		return id == other.id;
	}

private:
	u32 id;
};


template <typename AssetType>
inline std::ostream& operator<<(std::ostream& str, const AssetHandle<AssetType>& o) {
	str << "asset(" << o.getId() << ")";
	return str;
}
#endif
